
#!/usr/bin/env python
# -*- coding: utf-8 -*-
import threading
import wiringpi as wpi
import serial
import json
import time
import requests
import subprocess
from subprocess import Popen
from time import  sleep
import datetime

LAT = 0.0
LNG = 0.0
TEMP = 0.0
HUM = 0.0
LEV_L = 0.0
LEV_R = 0.0

none = 0
standby = 1
record = 2
succes = 3
error = 9

Cntrl_state = none

ser = serial.Serial("/dev/ttyS8",9600)
sensor_data = {}


wpi.wiringPiSetup()
wpi.pinMode(8,0) # sets pin 0 to input
wpi.pullUpDnControl(0,2); # sets WP pin 0 to pullup
wpi.softPwmCreate(9,0,100) # PWM PORT 9 , PWM RANGE  0 to 100


def getPiduinodata():
	global LAT,LNG
	global sensor_data
	global Cntrl_state

	while 1:
		line = ser.readline()
		line = line.rstrip()
		try:
			sensor_data  = json.loads(line)
			print "json data load!!"
			if (Cntrl_state != record) & (Cntrl_state != succes):
				Cntrl_state = standby

    			ID =  sensor_data['Device_ID']
			print ID
			print "LATITUDE:"
    			LAT = sensor_data['GPS']['LATITUDE']
			print LAT
			print "LONGITUDE:"
                	LNG = sensor_data['GPS']['LONGITUDE']
			print LNG
			print "TEMP:"
			TEMP = sensor_data['Envroment']['TEMP']
			print TEMP
			print "HUM:"
                	HUM = sensor_data['Envroment']['HUMIDITY']
			print HUM
			print "ULTRA SONIC Frq:"
    			FRQ = sensor_data['Ultrasonic']['FREQ']
			print FRQ
			print "ULTRA SONIC LEVEL L:"
			LEV_L = sensor_data['Ultrasonic']['LEVEL_LEFT']
			print LEV_L
                	print "ULTRA SONIC LEVEL R:"
                	LEV_R = sensor_data['Ultrasonic']['LEVEL_RIGHT']
			print LEV_R


        	except:
			print "json data load error"
			Cntrl_state = error

		time.sleep(1)

def Contrl_state_LED():
	global Cntrl_state
	while 1:
	        if Cntrl_state == standby :
			for n in range(2,9):
	                        wpi.softPwmWrite(9,n*10)
        	                wpi.delay(100)
                        for n in range(0,7):
                                wpi.softPwmWrite(9,100-(n*10))
                                wpi.delay(100)

		elif Cntrl_state == record :
			wpi.softPwmWrite(9,100)
			wpi.delay(100)

		elif Cntrl_state == succes :
                	wpi.softPwmWrite(9,0)
                	wpi.delay(500)
                	wpi.softPwmWrite(9,100)
                	wpi.delay(500)

		elif Cntrl_state == error :
                	wpi.softPwmWrite(9,0)
                	wpi.delay(50)
                	wpi.softPwmWrite(9,100)
                	wpi.delay(50)		

		else :
			wpi.softPwmWrite(9,0)
                	wpi.delay(500)


def IFTTT_post():
        global Cntrl_state
	try:
        	requests.post("http://maker.ifttt.com/trigger/Piduino/with/key/HYnOIDXrxNAsWytz8hR0q", json={"value1":sensor_data})
		print "IFTTT post!!"
		Cntrl_stete = succes
		time.sleep(0.5)
		Cntrl_state = none

        except:
                print "IFTTT upload error"
		Cntrl_state = error



def rec_sound():
        global Cntrl_state
	todaydetail  =    datetime.datetime.today()
        timestamp = todaydetail.strftime("%Y-%m-%d-%H:%M:%S")
        filename = timestamp + "LAT" + str(LAT) + "LNG" + str(LNG) + ".mp3"
#    filename = "test.mp3"
        cmd = "AUDIODEV=plughw:0,0 rec " + filename + " trim 0 10"
	try:
        	proc = Popen( cmd,shell=True )
		Cntrl_state = record
        	pid = proc.pid
        	print( "process id = %s" % pid )
		proc.wait()
		Cntrl_state = succes
		time.sleep(0.5)
		Cntrl_state = none
	except:
		print "Recording error"
		Cntrl_state = error


if __name__ == '__main__':

	getPiduinodata_thread = threading.Thread(target=getPiduinodata, name="getPiduinodata_thread")
	getPiduinodata_thread.setDaemon(True)
	getPiduinodata_thread.start()


        Contrl_state_LED_thread = threading.Thread(target=Contrl_state_LED, name="Contrl_state_LED_thread")
        Contrl_state_LED_thread.setDaemon(True)
        Contrl_state_LED_thread.start()

	while 1:
		if wpi.digitalRead(8) == 0:
    			rec_sound()
			IFTTT_post()
    			
		time.sleep(0.1)
